// MIEView.h : interface of the CMIEView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MIEVIEW_H__DB89A0E7_EE84_11D3_BE9D_000021E2D75A__INCLUDED_)
#define AFX_MIEVIEW_H__DB89A0E7_EE84_11D3_BE9D_000021E2D75A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMIEView : public CHtmlView
{
protected: // create from serialization only
	CMIEView();
	DECLARE_DYNCREATE(CMIEView)

// Attributes
public:
	CMIEDoc* GetDocument();
	void OnTitleChange(LPCTSTR lpszText);
	void OnDocumentComplete(LPCTSTR lpszUrl);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMIEView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMIEView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMIEView)
	afx_msg void OnBack();
	afx_msg void OnNext();
	afx_msg void OnHome();
	afx_msg void OnRefesh();
	afx_msg void OnStop();
	afx_msg void OnSearch();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MIEView.cpp
inline CMIEDoc* CMIEView::GetDocument()
   { return (CMIEDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MIEVIEW_H__DB89A0E7_EE84_11D3_BE9D_000021E2D75A__INCLUDED_)
